
#include "stdafx.h"
#include "AppIni.h" 

CAppIni g_ini("mobile_robot_simulation.ini");

CAppIni::CAppIni(const char *ini_path)
: CIni(ini_path)
{
	LoadData();
}

CAppIni::~CAppIni()
{
	SaveData();
}

void CAppIni::LoadData()
{
	TransferAllData (false);
}

void CAppIni::SaveData()
{
	TransferAllData (true);
}

void CAppIni::TransferAllData (bool bSave)
{
	Transfer (bSave, "robot_x", robot_x, 0.);
	Transfer (bSave, "robot_y", robot_y, 0.);
	Transfer (bSave, "robot_theta", robot_theta, 0.);

	Transfer (bSave, "scale", scale, 100.);
	Transfer (bSave, "offset_x", offset_x, 0.);
	Transfer (bSave, "offset_y", offset_y, 0.);

	Transfer (bSave, "map_file", map_file, MAX_PATH, ".\\map\\modelhouse.dxf");
	
	Transfer (bSave, "show_map", show_map, 1);
	Transfer (bSave, "show_2d_feature", show_2d_feature, 0);
	Transfer (bSave, "show_3d_feature", show_3d_feature, 0);
	Transfer (bSave, "show_beacon", show_beacon, 0);
	Transfer (bSave, "show_ceiling_landmark", show_ceiling_landmark, 0);
	Transfer (bSave, "show_floor_landmark", show_floor_landmark, 0);
	Transfer (bSave, "show_scanning_laser", show_scanning_laser, 1);
	Transfer (bSave, "show_robot", show_robot, 1);
}
